function varargout = cosmologui(varargin)
% COSMOLOGUI M-file for cosmologui.fig
%      COSMOLOGUI, by itself, creates a new COSMOLOGUI or raises the existing
%      singleton*.
%
%      H = cosmologui returns the handle to a new cosmologui or the handle to
%      the existing singleton*.
%
%      cosmologui('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in cosmologui.M with the given input arguments.
%
%      cosmologui('Property','Value',...) creates a new cosmologui or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before cosmologui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to cosmologui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help cosmologui

% Last Modified by GUIDE v2.5 04-Oct-2004 16:10:30

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @cosmologui_OpeningFcn, ...
                   'gui_OutputFcn',  @cosmologui_OutputFcn, ...
                   'gui_LayoutFcn',  @cosmologui_LayoutFcn, ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% -----------------------------------------------------------------
% -----------------------------------------------------------------
% --- Executes just before cosmologui is made visible.
function cosmologui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to cosmologui (see VARARGIN)

% Choose default command line output for cosmologui
handles.output = hObject;

movegui([10 -10]);

% choices associated with making the plot
handles.xcol=1; % Line number
handles.ycol=1; % Probability
handles.zcol=1; % Blank
handles.linewidth = 2; % default line width
handles.linecolor = [1 0 0]; % default line color (red)
handles.linestyle = '-'; % default line style (solid)
handles.clevels = [0.68 0.95]; % default confidence levels
handles.res = 0.1; % default smoothing width, as fraction of plot width
handles.nsampperbox = 5; % default no. samples per bin
handles.plottype = 1; % default: do contours and shading
handles.fontsize = 14;
handles.markersize=2; % for scatter plot
handles.colormap=1; % jet
handles.isheld = 0; % don't hold plots by default
handles.cuts=[]; % no cuts at first. Don't save these either.

% load in choices from last time
fid=fopen('cosmologui_prefs.mat');
if (fid>0)
    fclose(fid);
    htmp=load('cosmologui_prefs');
    % how to do this better!?
    handles.xcol=htmp.xcol;
    handles.ycol=htmp.ycol;
    handles.zcol=htmp.zcol;
    handles.linewidth=htmp.linewidth;
    handles.linecolor=htmp.linecolor;
    handles.linestyle=htmp.linestyle;
    handles.clevels=htmp.clevels;
    handles.res=htmp.res; %resolution
    handles.nsampperbox=htmp.nsampperbox;
    handles.plottype=htmp.plottype;
    handles.fontsize=htmp.fontsize;
    handles.markersize=htmp.markersize;
    handles.colormap=htmp.colormap;
    handles.isheld=htmp.isheld;
end

% set the menus to reflect the choices
set(handles.PlotTypePopup,'Value',handles.plottype);
set(handles.ResEdit,'Value',handles.res); % resolution
set(handles.HoldRadio,'Value',handles.isheld); % whether hold is on or not

if ~isempty(varargin)
    % samples may be given as arguments, so no need to read them in
    handles.samples=varargin{1}; % messy.. copying around big arrays?
    handles.names=varargin{2};
    handles.isampled=varargin{3};
    handles.cuts=varargin{4};
    handles.figno=varargin{5};

    handles=doxyzpulldown(handles);
    
    % open new figure, if necessary
    if (~isfield(handles,'figno'))
        scrsz = get(0,'ScreenSize');
        handles.figno=figure('Position',[10 10 scrsz(3)/2 scrsz(4)/2]);
    end
    plotsamps(handles);
    
else
    
    % load in some samples using the getsamps gui
     handles=Load_Callback(hObject, eventdata, handles);
% !!!!?? what if it comes back empty?     
end

set(handles.ColormapPopup,'Value',handles.colormap);
ColormapPopup_Callback(hObject, eventdata, handles);
set(handles.ResEdit,'String',handles.res); % resolution

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes cosmologui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = cosmologui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
%varargout{1} = handles.output;
if (isempty(handles))
    varargout=[];
else
  varargout = struct2cell(handles);
end


% --------------------------------------------------------------------
function handles=Load_Callback(hObject, eventdata, handles)
% hObject    handle to Open (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% load in some samples using the getsamps gui
[handles.samples,handles.names,handles.isampled,handles.cuts,h]=...
        getsamps('Position',[20 20 100 21]);

% shut down the getsamps gui
if (ishandle(h))
    status=close(h);
    if (status==0) fprintf(1,'Error closing figure\n'); end
else
    fprintf(1,'Error loading samples\n');
    return;
end
if (status==0) fprintf(1,'Error closing figure\n'); end

handles=doxyzpulldown(handles);

% open new figure, if necessary
if (~isfield(handles,'figno'))
    scrsz = get(0,'ScreenSize');
    handles.figno=figure('Position',[10 10 scrsz(3)/2 scrsz(4)/2]);
    handles.logoaxes=axes
    h=text(0.5,1.05,'Created using CosmoloGUI','color',[0 0.5 0.1])
    set(handles.logoaxes,'visible','off','layer','top')
    v=axes
    
end

plotsamps(handles);

guidata(hObject,handles); % store the changes


% --- Executes during object creation, after setting all properties.
function XlabelPopupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to XlabelPopupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in XlabelPopupmenu.
function XlabelPopupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to XlabelPopupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns XlabelPopupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from XlabelPopupmenu

handles.xcol = handles.xvals(get(handles.XlabelPopupmenu, 'Value'));
figure(handles.figno); clflogo % no point in overplotting if y axis is now different
plotsamps(handles);

% change the pull-down menus so eg. can't plot x against x
handles=doxyzpulldown(handles);
guidata(hObject,handles); % store the changes

% --- Executes during object creation, after setting all properties.
function YlabelPopupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to YlabelPopupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in YlabelPopupmenu.
function YlabelPopupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to YlabelPopupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns YlabelPopupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from YlabelPopupmenu

handles.ycol = handles.yvals(get(handles.YlabelPopupmenu, 'Value'));
figure(handles.figno); clflogo % no point in overplotting if y axis is now different
plotsamps(handles);

% change the pull-down menus so eg. can't plot x against x
handles=doxyzpulldown(handles);
guidata(hObject,handles); % store the changes


% --- Executes during object creation, after setting all properties.
function ZlabelPopupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ZlabelPopupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in ZlabelPopupmenu.
function ZlabelPopupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to ZlabelPopupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns ZlabelPopupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ZlabelPopupmenu

handles.zcol = handles.zvals(get(handles.ZlabelPopupmenu, 'Value'));

%if ((handles.zcol>1)&(handles.xcol==1)) % this is a bit naff..
%        handles.xcol=handles.isampled(2); 
%        fprintf(1,'*** NB. cant have X=Line number and Z not blank ***\n')
%        fprintf(1,'*** Switched X to next available column ***\n')
%end
%if ((handles.zcol>1)&(handles.ycol==1)) % this is a bit naff..
%        handles.ycol=handles.isampled(3); 
%        fprintf(1,'*** NB. cant have Y=Line number and Z not blank ***\n')
%        fprintf(1,'*** Switched Y to next available column ***\n')
%end

figure(handles.figno); clf % won't want to overplot if x axis has changed
plotsamps(handles);

% change the pull-down menus so eg. can't plot x against x
handles=doxyzpulldown(handles);

guidata(hObject,handles); % store the changes

% --- Executes during object creation, after setting all properties.
function PlotTypePopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PlotTypePopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in PlotTypePopup.
function PlotTypePopup_Callback(hObject, eventdata, handles)
% hObject    handle to PlotTypePopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns PlotTypePopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from PlotTypePopup

handles.plottype=get(hObject,'Value');
figure(handles.figno);
plotsamps(handles);
guidata(hObject,handles); % store the changes


% --- Executes during object creation, after setting all properties.
function ColormapPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ColormapPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in ColormapPopup.
function ColormapPopup_Callback(hObject, eventdata, handles)
% hObject    handle to ColormapPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns ColormapPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ColormapPopup

handles.colormap = get(handles.ColormapPopup, 'Value');
guidata(hObject,handles); % store the changes

figure(handles.figno);
switch handles.colormap
    case 1
        colormap(jet)
    case 2
        red
    case 3
        blue
    case 4
        green
    case 5
        bw
    case 6
        colormap(hsv)
    case 7
        yellowblue
end

% --- Executes on button press in InvertButton.
function InvertButton_Callback(hObject, eventdata, handles)
% hObject    handle to InvertButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

figure(handles.figno);
invert

% --- Executes on button press in LightenButton.
function LightenButton_Callback(hObject, eventdata, handles)
% hObject    handle to LightenButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

figure(handles.figno);
lighten


% --- Executes on button press in ClearButton.
function ClearButton_Callback(hObject, eventdata, handles)
% hObject    handle to ClearButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

figure(handles.figno); 
clflogo

% --- Executes during object creation, after setting all properties.
function ResEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ResEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%set(handles.ResEdit,'Value',handles.res); % resolution


% --- Executes on changing Text in Resolution field
function ResEdit_Callback(hObject, eventdata, handles)
% hObject    handle to ResEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ResEdit as text
%        str2double(get(hObject,'String')) returns contents of ResEdit as a double

handles.res=str2double(get(hObject,'String'))
guidata(hObject,handles); % store the changes

plotsamps(handles);


% --- Executes on button press in UpdateButton.
function UpdateButton_Callback(hObject, eventdata, handles)
% hObject    handle to UpdateButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

plotsamps(handles);

% -------------------------------------------------------------------
% --- Called by functions above, to sort out X,Y,Z pulldown menus
% after reading in new data, or changing the value xcol, ycol, zcol
function handles=doxyzpulldown(handles);

% check that we aren't trying to plot x against x
if (  ((handles.xcol==handles.ycol)&(handles.xcol~=1))    | ...
        ((handles.ycol==handles.zcol)&(handles.ycol~=1))    | ...
        ((handles.zcol==handles.xcol)&(handles.zcol~=1)) )
    % (if they are both 1 then this is a special case)
    handles.xcol=1; % reset everything to 1 
    handles.ycol=1; 
    handles.zcol=1; 
end    
    
% make the pulldown menus match the names
% and remove ycol and zcol from the list (unless 1)
handles.xvals=[];
for i=1:length(handles.isampled)
    is=handles.isampled(i);
    if ( ((is~=handles.ycol)|(is==1)) & ((is~=handles.zcol)|(is==1)) )
        handles.xvals=[handles.xvals is];
    end
end
% sort out a special case: if zcol isn't blank, can't have xcol=line no.
if (handles.zcol>1) 
    handles.xvals=handles.xvals(2:length(handles.xvals)); 
    tmpcell=handles.names(handles.xvals);
else
    tmpcell=handles.names(handles.xvals);
    tmpcell(1)={'Line number'};
end
set(handles.XlabelPopupmenu,'String',tmpcell);

% sim Y
handles.yvals=[];
for i=1:length(handles.isampled)
    is=handles.isampled(i);
    if ( ((is~=handles.xcol)|(is==1)) & ((is~=handles.zcol)|(is==1)) )
        handles.yvals=[handles.yvals is];
    end
end
% sort out a special case: if zcol isn't blank, can't have xcol=line no.
if (handles.zcol>1) 
    handles.yvals=handles.yvals(2:length(handles.yvals)); 
    tmpcell=handles.names(handles.yvals);
else
    tmpcell=handles.names(handles.yvals);
    tmpcell(1)={'Probability'};
end
set(handles.YlabelPopupmenu,'String',tmpcell);

% sim Z
handles.zvals=[];
for i=1:length(handles.isampled)
    is=handles.isampled(i);
    if ( ((is~=handles.xcol)|(is==1)) & ((is~=handles.ycol)|(is==1)) )
        handles.zvals=[handles.zvals is];
    end
end
% insert an extra option: probability up z axis:
if ((handles.xcol==1)|(handles.ycol==1))
  handles.zvals=1;
  tmpcell=handles.names(handles.zvals);
  tmpcell(1)={'- - - - - - - - - - -'};
else
  handles.zvals=[1 2 handles.zvals(2:length(handles.zvals))];
  tmpcell=handles.names(handles.zvals);
  tmpcell(1)={'- - - - - - - - - - -'};
  tmpcell(2)={'Probability'};
end
set(handles.ZlabelPopupmenu,'String',tmpcell);

% check that selected xyzcols were actually sampled from
ix=find(handles.xcol==handles.xvals); % hopefully length(ix)==1 !
iy=find(handles.ycol==handles.yvals);
iz=find(handles.zcol==handles.zvals);

if (isempty(ix)|isempty(iy)|isempty(iz))
    % one of the old columns was not sampled from in the new file
    handles.xcol=1; % reset everything to 1 
    handles.ycol=1; 
    handles.zcol=1; 
    set(handles.XlabelPopupmenu,'Value',1);
    set(handles.YlabelPopupmenu,'Value',1);
    set(handles.ZlabelPopupmenu,'Value',1);
else 
    % set up the popupmenus
    set(handles.XlabelPopupmenu,'Value',ix(1));
    set(handles.YlabelPopupmenu,'Value',iy(1));
    set(handles.ZlabelPopupmenu,'Value',iz(1));
end

% if the z axis is not blank, change the plottype menu
if (handles.zcol==1) % blank
    tmpcell={'Contours and Shading'; 'Contours'; 'Shading'; ...
            'Scatter (weights ignored)'; 'Histogram'};
    set(handles.PlotTypePopup,'String',tmpcell);
    if (handles.plottype>length(tmpcell))
        handles.plottype=1; % reset to default
    end
    set(handles.PlotTypePopup,'Value',handles.plottype);
end
if (handles.zcol==2) % probability
    % can't really do just contours in 3d, but otherwise same
    % as handles.zcol==1;
    tmpcell={'Scatter (weights ignored)';'Surface';'Histogram'};
    set(handles.PlotTypePopup,'String',tmpcell);
    if (handles.plottype>length(tmpcell))
        handles.plottype=1; % reset to default
    end
    set(handles.PlotTypePopup,'Value',handles.plottype);
end
if (handles.zcol>2) % probability
    % can't really do just contours in 3d, but otherwise same
    % as handles.zcol==1;
    tmpcell={'Scatter (weights ignored)'; '68 % isosurface'; '95 % isosurface'};
    set(handles.PlotTypePopup,'String',tmpcell);
    if (handles.plottype>length(tmpcell))
        handles.plottype=1; % reset to default
    end
    set(handles.PlotTypePopup,'Value',handles.plottype);
end

% --------------------------------------------------------------------
function Exit_Callback(hObject, eventdata, handles)
% hObject    handle to Exit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%pos_size = get(handles.figure1,'Position')
%user_response = modaldlg('Title','Confirm Close');
% couldn't get the above modaldlg to work yet.. see matlab help for 
% example of how it should work..

% save preferences for next time
% first remove the large data entry from handles, to save space
%rmfield(handles,'samples')
%save cosmologui_prefs handles
if (isfield(handles,'xcol'))
  xcol=handles.xcol;
  ycol=handles.ycol;
  zcol=handles.zcol;
  linewidth=handles.linewidth;
  linecolor=handles.linecolor;
  linestyle=handles.linestyle;
  clevels=handles.clevels;
  res=handles.res;
  nsampperbox=handles.nsampperbox;
  plottype=handles.plottype;
  fontsize=handles.fontsize;
  markersize=handles.markersize;
  colormap=handles.colormap;
  isheld=handles.isheld;
  save cosmologui_prefs xcol ycol zcol ...
      linewidth linecolor linestyle clevels res ...
      nsampperbox plottype fontsize markersize colormap isheld
  end
      
status=close(gcf);
if (status==0) fprintf('Error closing figure\n'); end


% --- Executes on button press in RotateButton.
function RotateButton_Callback(hObject, eventdata, handles)
% hObject    handle to RotateButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

figure(handles.figno)

if (handles.zcol>1)
  fprintf(1,'for i=1:5:360 view([(-20+i) 30]); pause(0.03); end\n')
  for i=1:5:360 
      figure(handles.figno)
      view([(-20+i) 30]); 
      pause(0.05); 
  end
end

% --- Executes on key press over cosmologui with no controls selected.
function cosmologui_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to cosmologui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on button press in SaveMovieButton.
function SaveMovieButton_Callback(hObject, eventdata, handles)
% hObject    handle to SaveMovieButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (handles.zcol>1)
    
    figure(handles.figno)
    
    % make an avi file see help avifile
    set(gcf,'Color',[1 1 1]); % want a white background for ppt movie
    for i=1:round(360/5)
        figure(handles.figno)
        view([(-20+i*5) 30]); 
        F(i)=getframe(gcf,[1 1 500 380]);
        pause(0.01); 
    end
    %movie(F)
    ! rm cosmologui.avi
    fprintf(1,'Compressing and saving movie to cosmologui.avi ...')
    if (ispc)
        movie2avi(F,'cosmologui.avi','compression','cinepak','fps',5,'quality',75)
    else
        movie2avi(F,'cosmologui.avi','fps',5); % unix/linux versions doesn't compress
    end    
    
    % set back to the way it was
    set(gcf,'Color',get(0,'defaultFigureColor'));
    
end


% --- Executes on button press in HoldRadio.
function HoldRadio_Callback(hObject, eventdata, handles)
% hObject    handle to HoldRadio (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of HoldRadio

handles.isheld=get(handles.HoldRadio,'Value');
guidata(hObject,handles); % store the changes


% --------------------------------------------------------------------
function EditMenu_Callback(hObject, eventdata, handles)
% hObject    handle to CutsMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function CutsMenu_Callback(hObject, eventdata, handles)
% hObject    handle to CutsMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% choose some cuts using the cutsamps gui
[handles.cuts h]=cutsamps(handles.samples,handles.names,handles.cuts,...
    'Position',[20 20 100 21]);

% shut down the getsamps gui
if (ishandle(h))
    status=close(h);
    if (status==0) fprintf(1,'Error closing figure\n'); end
else
    fprintf(1,'Error choosing cuts\n');
    return;
end
if (status==0) fprintf(1,'Error closing figure\n'); end

plotsamps(handles);

guidata(hObject,handles); % store the changes


% --- Executes on button press in PushPriors.
function PushPriors_Callback(hObject, eventdata, handles)
% hObject    handle to PushPriors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% choose some cuts using the cutsamps gui
[handles.cuts h]=cutsamps(handles.samples,handles.names,handles.cuts,...
    'Position',[20 20 100 21]);

% shut down the getsamps gui
if (ishandle(h))
    status=close(h);
    if (status==0) fprintf(1,'Error closing figure\n'); end
else
    fprintf(1,'Error choosing cuts\n');
    return;
end
if (status==0) fprintf(1,'Error closing figure\n'); end

plotsamps(handles);

guidata(hObject,handles); % store the changes


% --- Creates and returns a handle to the GUI figure. 
function h1 = cosmologui_LayoutFcn(policy)
% policy - create a new figure or use a singleton. 'new' or 'reuse'.

persistent hsingleton;
if strcmpi(policy, 'reuse') & ishandle(hsingleton)
    h1 = hsingleton;
    return;
end

appdata = [];
appdata.GUIDEOptions = struct(...
    'active_h', [], ...
    'taginfo', struct(...
    'figure', 2, ...
    'axes', 2, ...
    'text', 8, ...
    'popupmenu', 6, ...
    'pushbutton', 13, ...
    'edit', 2, ...
    'radiobutton', 2), ...
    'override', 0, ...
    'release', 13, ...
    'resize', 'none', ...
    'accessibility', 'callback', ...
    'mfile', 1, ...
    'callbacks', 1, ...
    'singleton', 1, ...
    'syscolorfig', 1, ...
    'blocking', 0, ...
    'lastSavedFile', 'D:\home\sarah\work\joint\cosmomc\mscripts\cosmologui.m');
appdata.lastValidTag = 'cosmologui_devel';
appdata.GUIDELayoutEditor = [];

h1 = figure(...
'Units','characters',...
'PaperUnits',get(0,'defaultfigurePaperUnits'),...
'Color',[0.87843137254902 0.874509803921569 0.890196078431373],...
'Colormap',[0 0 0.5625;0 0 0.625;0 0 0.6875;0 0 0.75;0 0 0.8125;0 0 0.875;0 0 0.9375;0 0 1;0 0.0625 1;0 0.125 1;0 0.1875 1;0 0.25 1;0 0.3125 1;0 0.375 1;0 0.4375 1;0 0.5 1;0 0.5625 1;0 0.625 1;0 0.6875 1;0 0.75 1;0 0.8125 1;0 0.875 1;0 0.9375 1;0 1 1;0.0625 1 1;0.125 1 0.9375;0.1875 1 0.875;0.25 1 0.8125;0.3125 1 0.75;0.375 1 0.6875;0.4375 1 0.625;0.5 1 0.5625;0.5625 1 0.5;0.625 1 0.4375;0.6875 1 0.375;0.75 1 0.3125;0.8125 1 0.25;0.875 1 0.1875;0.9375 1 0.125;1 1 0.0625;1 1 0;1 0.9375 0;1 0.875 0;1 0.8125 0;1 0.75 0;1 0.6875 0;1 0.625 0;1 0.5625 0;1 0.5 0;1 0.4375 0;1 0.375 0;1 0.3125 0;1 0.25 0;1 0.1875 0;1 0.125 0;1 0.0625 0;1 0 0;0.9375 0 0;0.875 0 0;0.8125 0 0;0.75 0 0;0.6875 0 0;0.625 0 0;0.5625 0 0],...
'IntegerHandle','off',...
'InvertHardcopy',get(0,'defaultfigureInvertHardcopy'),...
'KeyPressFcn','cosmologui(''cosmologui_devel_KeyPressFcn'',gcbo,[],guidata(gcbo))',...
'MenuBar','none',...
'Name','CosmoloGUI',...
'NumberTitle','off',...
'PaperPosition',get(0,'defaultfigurePaperPosition'),...
'PaperSize',[20.98404194812 29.67743169791],...
'PaperType',get(0,'defaultfigurePaperType'),...
'Position',[103.8 35.8461538461539 50 25.6153846153846],...
'Renderer',get(0,'defaultfigureRenderer'),...
'RendererMode','manual',...
'Resize','off',...
'HandleVisibility','callback',...
'Tag','cosmologui_devel',...
'UserData',[],...
'Behavior',get(0,'defaultfigureBehavior'),...
'Visible','on',...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'CosmoloGUI';

h2 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'ForegroundColor',[0 0.501960784313725 0],...
'HorizontalAlignment','right',...
'ListboxTop',0,...
'Position',[31.8 23.6153846153846 12.2 1.15384615384615],...
'String','CosmoloGUI',...
'Style','text',...
'Tag','CosmoloGUI',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'ZlabelPopupmenu';

h3 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[1 1 1],...
'Callback','cosmologui(''ZlabelPopupmenu_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[7.8 15.9230769230769 40.2 1.92307692307692],...
'String','Load samples first...',...
'Style','popupmenu',...
'Value',1,...
'CreateFcn', {@local_CreateFcn, 'cosmologui(''ZlabelPopupmenu_CreateFcn'',gcbo,[],guidata(gcbo))', appdata} ,...
'Tag','ZlabelPopupmenu',...
'Behavior',get(0,'defaultuicontrolBehavior'));

appdata = [];
appdata.lastValidTag = 'YlabelPopupmenu';

h4 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[1 1 1],...
'Callback','cosmologui(''YlabelPopupmenu_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'HorizontalAlignment','left',...
'ListboxTop',0,...
'Position',[7.8 18.2307692307692 40.2 1.92307692307692],...
'String','Load samples first...',...
'Style','popupmenu',...
'TooltipString','Select columns which are sampled from. Names file must be correct when loading samples.',...
'Value',1,...
'CreateFcn', {@local_CreateFcn, 'cosmologui(''YlabelPopupmenu_CreateFcn'',gcbo,[],guidata(gcbo))', appdata} ,...
'Tag','YlabelPopupmenu',...
'Behavior',get(0,'defaultuicontrolBehavior'));

appdata = [];
appdata.lastValidTag = 'ztext';

h5 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'FontSize',12,...
'ForegroundColor',[0 0.501960784313725 0],...
'ListboxTop',0,...
'Position',[1.8 16.2307692307692 4.2 1.61538461538462],...
'String','Z:',...
'Style','text',...
'Tag','ztext',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'ytext';

h6 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'FontSize',12,...
'ForegroundColor',[0 0.501960784313725 0],...
'ListboxTop',0,...
'Position',[1.8 18.5384615384615 4.2 1.61538461538462],...
'String','Y:',...
'Style','text',...
'Tag','ytext',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'PlotTypePopup';

h7 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[1 1 1],...
'Callback','cosmologui(''PlotTypePopup_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[7.8 10.5384615384615 40.2 1.92307692307692],...
'String',{  'Contours and Shading'; 'Contours'; 'Shading'; 'Scatter (weights ignored)'; 'Histogram (weights ignored)' },...
'Style','popupmenu',...
'TooltipString','Change type of plot. Press `Update'' to activate new selection.',...
'Value',1,...
'CreateFcn', {@local_CreateFcn, 'cosmologui(''PlotTypePopup_CreateFcn'',gcbo,[],guidata(gcbo))', appdata} ,...
'Tag','PlotTypePopup',...
'Behavior',get(0,'defaultuicontrolBehavior'));

appdata = [];
appdata.lastValidTag = 'ColormapPopup';

h8 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[1 1 1],...
'Callback','cosmologui(''ColormapPopup_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[7.8 3.07692307692308 40.2 1.92307692307692],...
'String',{  'jet'; 'red'; 'blue'; 'green'; 'black/white'; 'hsv'; 'yellow/blue' },...
'Style','popupmenu',...
'TooltipString','Choose a colormap from a selection. (Could also change it by typing at the matlab prompt).',...
'Value',1,...
'CreateFcn', {@local_CreateFcn, 'cosmologui(''ColormapPopup_CreateFcn'',gcbo,[],guidata(gcbo))', appdata} ,...
'Tag','ColormapPopup',...
'Behavior',get(0,'defaultuicontrolBehavior'));

appdata = [];
appdata.lastValidTag = 'ColormapText';

h9 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'FontSize',10,...
'ForegroundColor',[0 0.501960784313725 0],...
'ListboxTop',0,...
'Position',[1.8 5.30769230769231 13.8 1.23076923076923],...
'String','Colormap:',...
'Style','text',...
'Tag','ColormapText',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'InvertButton';

h10 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','cosmologui(''InvertButton_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[19.8 5.23076923076923 13.2 1.76923076923077],...
'String','Invert',...
'TooltipString','Invert the color map.',...
'Tag','InvertButton',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'LightenButton';

h11 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','cosmologui(''LightenButton_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[33.8 5.23076923076923 13.2 1.76923076923077],...
'String','Lighten',...
'TooltipString','Lighten the color map.',...
'Tag','LightenButton',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'ClearButton';

h12 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','cosmologui(''ClearButton_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[33.8 0.153846153846154 13.2 1.76923076923077],...
'String','Clear',...
'TooltipString','Clear the plot (clf).',...
'Tag','ClearButton',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'ResEdit';

h13 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[1 1 1],...
'Callback','cosmologui(''ResEdit_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',11,...
'ListboxTop',0,...
'Position',[19.8 8.53846153846154 9.4 1.61538461538462],...
'String','0.05',...
'Style','edit',...
'TooltipString','Change resolution (as a fraction of axis width). Press `Update'' button to update the plot.',...
'CreateFcn', {@local_CreateFcn, 'cosmologui(''ResEdit_CreateFcn'',gcbo,[],guidata(gcbo))', appdata} ,...
'Tag','ResEdit',...
'Behavior',get(0,'defaultuicontrolBehavior'));

appdata = [];
appdata.lastValidTag = 'ResText';

h14 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'FontSize',10,...
'ForegroundColor',[0 0.501960784313725 0],...
'ListboxTop',0,...
'Position',[3.8 8.92307692307692 13 1.23076923076923],...
'String','Resolution:',...
'Style','text',...
'TooltipString','Change the resolution (for contour plots).',...
'Tag','ResText',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'Load';

h15 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','cosmologui(''Load_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[7.8 23.1538461538462 13.2 1.76923076923077],...
'String','Load',...
'TooltipString','Load new samples files. Can overlay contours.',...
'Tag','Load',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'Exit';

h16 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','cosmologui(''Exit_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[1.8 0.153846153846154 13.2 1.76923076923077],...
'String','Exit',...
'TooltipString','Exit and close CosmoGUI.',...
'Tag','Exit',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'XlabelPopupmenu';

h17 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[1 1 1],...
'Callback','cosmologui(''XlabelPopupmenu_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'HorizontalAlignment','left',...
'ListboxTop',0,...
'Position',[7.8 20.5384615384615 40.2 1.92307692307692],...
'String','Load samples first...',...
'Style','popupmenu',...
'TooltipString','Select columns which are sampled from. Names file must be correct when loading samples.',...
'Value',1,...
'CreateFcn', {@local_CreateFcn, 'cosmologui(''XlabelPopupmenu_CreateFcn'',gcbo,[],guidata(gcbo))', appdata} ,...
'Tag','XlabelPopupmenu',...
'Behavior',get(0,'defaultuicontrolBehavior'));

appdata = [];
appdata.lastValidTag = 'xtext';

h18 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'FontSize',12,...
'ForegroundColor',[0 0.501960784313725 0],...
'ListboxTop',0,...
'Position',[1.8 20.8461538461538 4.2 1.61538461538462],...
'String','X:',...
'Style','text',...
'Tag','xtext',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'RotateButton';

h19 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','cosmologui(''RotateButton_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[11.8 13.7692307692308 13.2 1.76923076923077],...
'String','Rotate',...
'TooltipString','Rotate a 3d plot by 360 degrees about a standard axis.',...
'Tag','RotateButton',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'SaveMovieButton';

h20 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','cosmologui(''SaveMovieButton_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[25.8 13.7692307692308 18 1.76923076923077],...
'String','Save Movie',...
'TooltipString','Save a movie to cosmogui.avi (of rotating 3d plot by 360 degrees about a standard axis).',...
'Tag','SaveMovieButton',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'HoldRadio';

h21 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','cosmologui(''HoldRadio_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[31.8 8.61538461538462 16.2 1.53846153846154],...
'String','Hold',...
'Style','radiobutton',...
'TooltipString','If button is on (filled circle) then subsequent plots will overlay on previous plots.',...
'Tag','HoldRadio',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );

appdata = [];
appdata.lastValidTag = 'PushPriors';

h22 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback','cosmologui(''PushPriors_Callback'',gcbo,[],guidata(gcbo))',...
'FontSize',10,...
'ListboxTop',0,...
'Position',[17.8 0.0769230769230769 13.2 1.76923076923077],...
'String','Priors',...
'TooltipString','Apply cuts (aka top hat priors).',...
'Tag','PushPriors',...
'Behavior',get(0,'defaultuicontrolBehavior'),...
'CreateFcn', {@local_CreateFcn, '', appdata} );


hsingleton = h1;


% --- Set application data first then calling the CreateFcn. 
function local_CreateFcn(hObject, eventdata, createfcn, appdata)

if ~isempty(appdata)
   names = fieldnames(appdata);
   for i=1:length(names)
       name = char(names(i));
       setappdata(hObject, name, getfield(appdata,name));
   end
end

if ~isempty(createfcn)
   eval(createfcn);
end


% --- Handles default GUIDE GUI creation and callback dispatch
function varargout = gui_mainfcn(gui_State, varargin)


%   GUI_MAINFCN provides these command line APIs for dealing with GUIs
%
%      COSMOLOGUI, by itself, creates a new COSMOLOGUI or raises the existing
%      singleton*.
%
%      H = COSMOLOGUI returns the handle to a new COSMOLOGUI or the handle to
%      the existing singleton*.
%
%      COSMOLOGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in COSMOLOGUI.M with the given input arguments.
%
%      COSMOLOGUI('Property','Value',...) creates a new COSMOLOGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before untitled_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to untitled_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".

%   Copyright 1984-2004 The MathWorks, Inc.
%   $Revision: 1.4.6.8 $ $Date: 2004/04/15 00:06:57 $

gui_StateFields =  {'gui_Name'
                    'gui_Singleton'
                    'gui_OpeningFcn'
                    'gui_OutputFcn'
                    'gui_LayoutFcn'
                    'gui_Callback'};
gui_Mfile = '';
for i=1:length(gui_StateFields)
    if ~isfield(gui_State, gui_StateFields{i})
        error('Could not find field %s in the gui_State struct in GUI M-file %s', gui_StateFields{i}, gui_Mfile);        
    elseif isequal(gui_StateFields{i}, 'gui_Name')
        gui_Mfile = [gui_State.(gui_StateFields{i}), '.m'];
    end
end

numargin = length(varargin);

if numargin == 0
    % COSMOLOGUI
    % create the GUI
    gui_Create = 1;
elseif isequal(ishandle(varargin{1}), 1) && ispc && iscom(varargin{1}) && isequal(varargin{1},gcbo)
    % COSMOLOGUI(ACTIVEX,...)    
    vin{1} = gui_State.gui_Name;
    vin{2} = [get(varargin{1}.Peer, 'Tag'), '_', varargin{end}];
    vin{3} = varargin{1};
    vin{4} = varargin{end-1};
    vin{5} = guidata(varargin{1}.Peer);
    feval(vin{:});
    return;
elseif ischar(varargin{1}) && numargin>1 && isequal(ishandle(varargin{2}), 1)
    % COSMOLOGUI('CALLBACK',hObject,eventData,handles,...)
    gui_Create = 0;
else
    % COSMOLOGUI(...)
    % create the GUI and hand varargin to the openingfcn
    gui_Create = 1;
end

if gui_Create == 0
    varargin{1} = gui_State.gui_Callback;
    if nargout
        [varargout{1:nargout}] = feval(varargin{:});
    else
        feval(varargin{:});
    end
else
    if gui_State.gui_Singleton
        gui_SingletonOpt = 'reuse';
    else
        gui_SingletonOpt = 'new';
    end
    
    % Open fig file with stored settings.  Note: This executes all component
    % specific CreateFunctions with an empty HANDLES structure.
    
    % Do feval on layout code in m-file if it exists
    if ~isempty(gui_State.gui_LayoutFcn)
        gui_hFigure = feval(gui_State.gui_LayoutFcn, gui_SingletonOpt);
        % openfig (called by local_openfig below) does this for guis without
        % the LayoutFcn. Be sure to do it here so guis show up on screen.
        movegui(gui_hFigure,'onscreen')
    else
        gui_hFigure = local_openfig(gui_State.gui_Name, gui_SingletonOpt);            
        % If the figure has InGUIInitialization it was not completely created
        % on the last pass.  Delete this handle and try again.
        if isappdata(gui_hFigure, 'InGUIInitialization')
            delete(gui_hFigure);
            gui_hFigure = local_openfig(gui_State.gui_Name, gui_SingletonOpt);            
        end
    end
    
    % Set flag to indicate starting GUI initialization
    setappdata(gui_hFigure,'InGUIInitialization',1);

    % Fetch GUIDE Application options
    gui_Options = getappdata(gui_hFigure,'GUIDEOptions');
    
    if ~isappdata(gui_hFigure,'GUIOnScreen')
        % Adjust background color
        if gui_Options.syscolorfig 
            set(gui_hFigure,'Color', get(0,'DefaultUicontrolBackgroundColor'));
        end

        % Generate HANDLES structure and store with GUIDATA
        guidata(gui_hFigure, guihandles(gui_hFigure));
    end
    
    % If user specified 'Visible','off' in p/v pairs, don't make the figure
    % visible.
    gui_MakeVisible = 1;
    for ind=1:2:length(varargin)
        if length(varargin) == ind
            break;
        end
        len1 = min(length('visible'),length(varargin{ind}));
        len2 = min(length('off'),length(varargin{ind+1}));
        if ischar(varargin{ind}) && ischar(varargin{ind+1}) && ...
                strncmpi(varargin{ind},'visible',len1) && len2 > 1
            if strncmpi(varargin{ind+1},'off',len2)
                gui_MakeVisible = 0;
            elseif strncmpi(varargin{ind+1},'on',len2)
                gui_MakeVisible = 1;
            end
        end
    end
    
    % Check for figure param value pairs
    for index=1:2:length(varargin)
        if length(varargin) == index
            break;
        end
        try set(gui_hFigure, varargin{index}, varargin{index+1}), catch break, end
    end

    % If handle visibility is set to 'callback', turn it on until finished
    % with OpeningFcn
    gui_HandleVisibility = get(gui_hFigure,'HandleVisibility');
    if strcmp(gui_HandleVisibility, 'callback')
        set(gui_hFigure,'HandleVisibility', 'on');
    end
    
    feval(gui_State.gui_OpeningFcn, gui_hFigure, [], guidata(gui_hFigure), varargin{:});
    
    if ishandle(gui_hFigure)
        % Update handle visibility
        set(gui_hFigure,'HandleVisibility', gui_HandleVisibility);
        
        % Make figure visible
        if gui_MakeVisible
            set(gui_hFigure, 'Visible', 'on')
            if gui_Options.singleton 
                setappdata(gui_hFigure,'GUIOnScreen', 1);
            end
        end

        % Done with GUI initialization
        rmappdata(gui_hFigure,'InGUIInitialization');
    end
    
    % If handle visibility is set to 'callback', turn it on until finished with
    % OutputFcn
    if ishandle(gui_hFigure)
        gui_HandleVisibility = get(gui_hFigure,'HandleVisibility');
        if strcmp(gui_HandleVisibility, 'callback')
            set(gui_hFigure,'HandleVisibility', 'on');
        end
        gui_Handles = guidata(gui_hFigure);
    else
        gui_Handles = [];
    end
    
    if nargout
        [varargout{1:nargout}] = feval(gui_State.gui_OutputFcn, gui_hFigure, [], gui_Handles);
    else
        feval(gui_State.gui_OutputFcn, gui_hFigure, [], gui_Handles);
    end
    
    if ishandle(gui_hFigure)
        set(gui_hFigure,'HandleVisibility', gui_HandleVisibility);
    end
end    

function gui_hFigure = local_openfig(name, singleton)

% openfig with three arguments was new from R13. Try to call that first, if
% failed, try the old openfig.
try 
    gui_hFigure = openfig(name, singleton, 'auto');
catch
    % OPENFIG did not accept 3rd input argument until R13,
    % toggle default figure visible to prevent the figure
    % from showing up too soon.
    gui_OldDefaultVisible = get(0,'defaultFigureVisible');
    set(0,'defaultFigureVisible','off');
    gui_hFigure = openfig(name, singleton);
    set(0,'defaultFigureVisible',gui_OldDefaultVisible);
end

